XIncludeFile "disconnect.pbi" ;Must be in front of all HTTP Query Includes!!
XIncludeFile "http.pbi"
XIncludeFile "downloaddialog.pbi" ;Must be in front of all code using Windows!!

; ---- EXAMPLES ----

; You still have to manually initialize the network first
InitNetwork()

;- SimpleHTTP_GET
Debug "SimpleHTTP_GET Example:"

; Download a file directly to a string
Debug SimpleHTTP_GET("http://www.cs.tut.fi/cgi-bin/run/~jkorpela/echo.cgi")
Debug SimpleHTTP_GET("http://www.fds-team.de/")

;- SimpleHTTP_POST
Debug "-------------------"
Debug "SimpleHTTP_POST Example:"

NewList PostData.HTTPQuery_KeyValue()

AddElement(PostData())
PostData()\key = "key1"
PostData()\value = "value!with%special$characters&"

AddElement(PostData())
PostData()\key = "key2"
PostData()\value = "Here" + #CRLF$ + "some" + #CRLF$ + "value" + #CRLF$ + "with" + #CRLF$ + "newlines"

; Perform a POST request using the key-value pairs given above
; In this case we use multipart as encoding, but the other method also works for most scripts
Debug SimpleHTTP_POST("http://www.cs.tut.fi/cgi-bin/run/~jkorpela/echo.cgi", PostData(), #True)

;- SimpleHTTP_GET_File
Debug "-------------------"
Debug "SimpleHTTP_GET_File Example:"

; This downloads a file and on-the-fly calculates the md5 checksum.
Define filename.s = GetTemporaryDirectory() + "5MB.qsc"

Define md5.s = SimpleHTTP_GET_File("http://speedtest.qsc.de/5MB.qsc", filename)
If LCase(md5) = "8075a5bbe46e4d00d8e5eec439cf9a39"
  Debug "Checksum okay!"
Else
  Debug "Something was wrong with the download! MD5 checksum doesnt match!"
  Debug "MD5 = " + md5
EndIf

;You may want to delete this file ;-)
;DeleteFile(filename)

;- SimpleHTTP_GET_Lines
Debug "-------------------"
Debug "SimpleHTTP_GET_Lines Example:"

NewList Lines.s()

; This will perform a GET request and add each line to the output list
If SimpleHTTP_GET_Lines("http://www.cs.tut.fi/cgi-bin/run/~jkorpela/echo.cgi", Lines())
  Debug "Downloaded " + Str(ListSize(Lines())) + " lines"
  
  ; Show the lines
  ForEach Lines()
    Debug "Line: " + Lines()
  Next
  
EndIf

;- DownloadDialog
Debug "-------------------"
Debug "DownloadDialog Example:"

Define *dl = DownloadDialog_Create()

If *dl
	DownloadDialog_AddFile(*dl, "http://speedtest.qsc.de/5MB.qsc", GetTemporaryDirectory() + "5MB.qsc")
	DownloadDialog_AddFile(*dl, "http://speedtest.tweak.nl/10mb.bin", GetTemporaryDirectory() + "10mb.bin")
	;DownloadDialog_AddFile(*dl, "http://speedtest.qsc.de/10GB.qsc", "/dev/null")
	DownloadDialog_Start(*dl)
	
	While #True
		Define Event.i = WaitWindowEvent()
		; You can handle your own events here as usual ...
		
		If DownloadDialog_Status(*dl) <> #DOWNLOAD_STATUS_INPROGRESS
			Break
		EndIf
	Wend
	
	Debug "Overall download status is: " + Str(DownloadDialog_Status(*dl))
	
	While #True
		Define filename.s = DownloadDialog_NextFailedFile(*dl)
		If filename = ""
			Break
		EndIf
		
		Debug "File " + filename + " could not be downloaded"
	Wend
	
	DownloadDialog_Free(*dl)
EndIf
; IDE Options = PureBasic 5.11 (Linux - x64)
; CursorPosition = 6
; EnableXP